## adios2 2.10.1+dfsg1

=== debian/changelog ===
adios2 (2.10.1+dfsg1-12) unstable; urgency=medium

  * adios2 cmake config files check if plugin files are installed, so
    set libadios2-*-core-2.10 Depends: libadios2-*-plugins
    instead of Recommends. Set debian/source/lintian-overrides to
    ignore intra-source-package-circular-dependency, since plugin
    packages get Depends: *core via ${shlibs:Depends}. The two have to
    go together. Closes: #1084255.

 -- Drew Parsons <dparsons@debian.org>  Sat, 12 Oct 2024 20:20:05 +0200

adios2 (2.10.1+dfsg1-11) unstable; urgency=medium

  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Oct 2024 12:35:28 +0200

adios2 (2.10.1+dfsg1-10) experimental; urgency=medium

  * debian/tests Restrictions: allow-stderr in MPI tests.
    arm64 started sending compile warnings to stderr compiling the
    gray-scott_pdf-calc simulation for adios2-mpi-examples.

 -- Drew Parsons <dparsons@debian.org>  Mon, 16 Sep 2024 10:14:46 +0200

adios2 (2.10.1+dfsg1-9) experimental; urgency=medium

  * debian/tests/adios2-mpi-examples: fix syntax finding tests

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Sep 2024 22:38:35 +0200

adios2 (2.10.1+dfsg1-8) experimental; urgency=medium

  * debian/tests/adios2-mpi-examples: run *Writer before *Reader
    to ensure adios2_hello_bpReader_mpi passes on arm64

 -- Drew Parsons <dparsons@debian.org>  Sat, 14 Sep 2024 16:24:17 +0200

adios2 (2.10.1+dfsg1-7) experimental; urgency=medium

  * debian/tests: update names of *Read, *Write to run write tests
    before read tests. Collect executable files only.

 -- Drew Parsons <dparsons@debian.org>  Fri, 13 Sep 2024 11:48:53 +0200

adios2 (2.10.1+dfsg1-6) experimental; urgency=medium

  * debian/tests/adios2-mpi-examples: skip globalArray1DRead_*
    (i.e. add adios2_basics_globalArray1DRead_c to skips)

 -- Drew Parsons <dparsons@debian.org>  Thu, 12 Sep 2024 16:15:37 +0200

adios2 (2.10.1+dfsg1-5) experimental; urgency=medium

  * update skips in debian/tests examples tests
    - examples now use an adios2_ prefix.
    - skip globalArray1DRead_f (basic) in MPI examples

 -- Drew Parsons <dparsons@debian.org>  Wed, 11 Sep 2024 20:41:05 +0200

adios2 (2.10.1+dfsg1-4) experimental; urgency=medium

  * add debian patch fix_examples_cmake.patch to fix examples
    - only add MPI support if ADIOS2_HAVE_MPI is set.
    - only build plugins/engine if ADIOS2_add_examples_plugins_engine
      is set (i.e. skip engines, since the plugin is not built)
  * update debian/tests/adios2-{mpi,serial}-examples to use
    adios2.is_built_with_mpi to test for serial or MPI build.
  * update debian/tests/adios2-mpi-examples
    - update names of python tests
    - skip simulations gray-scott, gray-scott-struct,
      and queryWorker (basics). They do run, but need additional
      config files from the source dirs
  * debian patch fix_example_hello_bpFWriteCRead_PR4239.patch applies
    upstream PR#4239 to fix CppReader in the hello bpFWriteCRead
    example.

 -- Drew Parsons <dparsons@debian.org>  Tue, 10 Sep 2024 22:47:53 +0200

adios2 (2.10.1+dfsg1-3) experimental; urgency=medium

  * update fix_cmake_dill_ffi.patch to not impose DILL_NATIVE_ONLY if
    NATIVE_ARCH is UNSUPPORTED. i.e. enable libffi emulation on
    unsupported arches (riscv64, s390x, etc)

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Sep 2024 13:45:26 +0200

adios2 (2.10.1+dfsg1-2) experimental; urgency=medium

  * debian patch fix_cmake_dill_ffi.patch fixes dill's FindLibFFI.cmake
    to set LIBFFI_FOUND when found with pkgconfig. Needed for less
    common arches (riscv64, s390x, etc) not directly supported by dill.
  * debian/tests Depends: libadios2-serial-plugins, libadios2-mpi-plugins

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Sep 2024 10:56:43 +0200

adios2 (2.10.1+dfsg1-1) experimental; urgency=medium

  [ Francesco Ballarin ]
  * New upstream release. Closes: #1077346.
    - new ABI 2.10
  * Add Francesco Ballarin to uploaders
  * Drop thirdparty_soname.patch: the patch used to add the version of the
    third party library perfstubs to its soname, but upstream has now decided
    to give its own version number to the third party library.
  * Drop python_fix.patch, which has been integrated upstream
  * Drop fix_examples_BeginStep_PR3856.patch: PR #3856 has been included in
    upstream release 2.10.0.
  * Refresh remaining patches
  * Change CMake variable -DEVPATH_TRANSPORT_MODULES from OFF to ON to fix
    linking error
     /usr/bin/ld: lib/x86_64-linux-gnu/libadios2_serial_evpath.so.2.10.0:
     undefined reference to `cmfabric_add_static_transport'
    - Provide transport modules in libadios2-mpi-auxiliary-2
    - Closes: #1070338

  [ Drew Parsons ]
  * Handle RUNPATH configuration with -DCMAKE_SKIP_INSTALL_RPATH=ON
  * update debian patch multiple_python_versions.patch to activate
    DetectPythonOptions in toplevel CMakeLists.txt.
  * update python installation
    - python entry scripts now provided by python3-adios2
    - install bindings/__init__.py with base python component
      and bindings extensions (.so) in -serial, -mpi packages
    - debian patch python_bindings_flavour.patch moves handling of
      serial or mpi flavor to adios2/bindings/__init__/py
    - drop debian patch Skip-install-init-py.patch
    - install common python files "twice" into the same location in
      python3-adios to avoid dh_missing complaints
  * Build-Depends: pkgconf not pkg-config
  * add man page (help2man) for new script adios2_campaign_manager
  * debian/rules: define ADIOS2_SOVERSION as MAJOR.MINOR
    (i.e. 2.10 not just 2)
  * provide plugin libraries in libadios2-{serial,mpi}-plugins.
    Required since plugins do not carry a soname and the plugin
    installation dir is not ABI-specific.
    libadios2-*-plugins Replaces/Breaks: libadios2-*-core-2
    libadios2-*-core-2.10 Recommends: libadios2-*-plugins.

 -- Drew Parsons <dparsons@debian.org>  Sun, 08 Sep 2024 10:06:01 +0200

=== debian/control ===
Source: adios2
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Build-Depends:
    architecture-is-64-bit, architecture-properties,
    debhelper-compat (= 13),
    dh-cmake,
    dh-cmake-compat (= 1),
    dh-sequence-cmake,
    dh-sequence-ctest,
    dh-sequence-python3,
    cmake,
    ninja-build,
    gfortran,
    pkgconf,
    libenet-dev,
    libpugixml-dev,
    libsodium-dev,
    libyaml-cpp-dev,
    pybind11-dev,
    libgtest-dev,
    nlohmann-json3-dev,
    python3-all-dev,
    python3-numpy,
    libblosc-dev,
    libbz2-dev,
    libpng-dev,
    libczmq-dev,
    libhdf5-serial-dev,
    libhdf5-mpi-dev,
    libfabric-dev,
    libffi-dev,
    libucx-dev [amd64 arm64],
    mpi-default-dev,
    python3-mpi4py
Standards-Version: 4.7.0
Section: libs
Homepage: https://github.com/ornladios/ADIOS2
Vcs-Browser: https://salsa.debian.org/science-team/adios2
Vcs-Git: https://salsa.debian.org/science-team/adios2.git

Package: adios2-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - tool data
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains tool data for ADIOS2.

Package: adios2-scripts
Architecture: all
Multi-Arch: foreign
Depends: ${python3:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - scripts
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains scripts for ADIOS2.

Package: adios2-serial-bin
Architecture: any
Depends: adios2-scripts, ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - binary tools (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains binary tools for ADIOS2.

Package: libadios2-serial-core-2.10
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libadios2-serial-plugins (= ${binary:Version})
Description: ADIOS2 Adaptable IO system for simulations - core libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-plugins
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libadios2-serial-core-2
Breaks: libadios2-serial-core-2
Description: ADIOS2 Adaptable IO system for simulations - core libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the plugin libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libadios2-serial-core-2.10 (= ${binary:Version}),
 libadios2-common-core-dev (= ${binary:Version}),
 libadios2-serial-auxiliary-dev (= ${binary:Version}),
 ${misc:Depends}
Description: Adaptable IO system for simulations - core development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the core development files for the serial build
 of ADIOS2.

Package: libadios2-serial-c-2.10
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-c-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-c-2.10 (= ${binary:Version}),
    libadios2-common-c-dev (= ${source:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Description: Adaptable IO system for simulations - C binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-c++11-2.10
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - C++11 binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C++11 binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-c++11-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-c++11-2.10 (= ${binary:Version}),
    libadios2-common-c++11-dev (= ${source:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Description: Adaptable IO system for simulations - C++11 binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the C++11 binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-fortran-2.10
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - Fortran binding libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Fortran binding libraries for the serial build of
 ADIOS2.

Package: libadios2-serial-fortran-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-fortran-2.10 (= ${binary:Version}),
    libadios2-serial-core-dev (= ${binary:Version}),
    ${misc:Depends}
Conflicts: libadios2-mpi-fortran-dev
Description: Adaptable IO system for simulations - Fortran binding development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the Fortran binding development files for the serial
 build of ADIOS2.

Package: libadios2-serial-auxiliary-2.10
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ADIOS2 Adaptable IO system for simulations - auxiliary libraries (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains the auxiliary thirdparty libraries required
 by the serial build of ADIOS2, which are not yet packaged separately:
  - atl
  - dill
  - EVPath
  - ffs
  - perfstubs

Package: libadios2-serial-auxiliary-dev
Architecture: any
Multi-Arch: same
Depends:
    libadios2-serial-auxiliary-2.10 (= ${binary:Version}),
    ${misc:Depends}
Description: Adaptable IO system for simulations - auxiliary development files (serial)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for
 scientists to describe the data in their code that may need to be
 written, read, or processed outside of the running simulation. By
 providing an external to the code XML file describing the various
 elements, their types, and how you wish to process them this run, the
 routines in the host code (either Fortran or C) can transparently
 change how they process the data.
 .
 This package contains  binding development files for the auxiliary

=== debian/tests/control ===
Tests: adios2-serial-test, adios2-serial-examples
Depends: libadios2-serial-c-dev,
 libadios2-serial-c++11-dev,
 libadios2-serial-fortran-dev,
 libadios2-serial-plugins,
 python3-adios2,
 python3-all,
 @builddeps@

Tests: adios2-mpi-test, adios2-mpi-examples
Depends: libadios2-mpi-c-dev,
 libadios2-mpi-c++11-dev,
 libadios2-mpi-fortran-dev,
 libadios2-mpi-plugins,
 python3-adios2, python3-adios2-mpi,
 python3-all,
 @builddeps@
Restrictions: allow-stderr

## adios2 2.10.2%2Bdfsg1

=== examples/basics/globalArrayND/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2BasicsGlobalArrayNDExample)

if(NOT TARGET adios2_core)
  set(_components CXX)

  find_package(MPI COMPONENTS C)
  if(MPI_FOUND)
    # Workaround for various MPI implementations forcing the link of C++ bindings
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)

    list(APPEND _components MPI)
  endif()

  find_package(ADIOS2 REQUIRED COMPONENTS ${_components})
endif()

add_executable(adios2_basics_globalArrayNDWrite globalArrayNDWrite.cpp)
target_link_libraries(adios2_basics_globalArrayNDWrite adios2::cxx11)
install(TARGETS adios2_basics_globalArrayNDWrite RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(ADIOS2_HAVE_MPI)
  add_executable(adios2_basics_globalArrayNDWrite_mpi globalArrayNDWrite.cpp)
  target_link_libraries(adios2_basics_globalArrayNDWrite_mpi adios2::cxx11_mpi MPI::MPI_C)
  install(TARGETS adios2_basics_globalArrayNDWrite_mpi RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== examples/hello/sstReader/CMakeLists.txt ===
#------------------------------------------------------------------------------#
# Distributed under the OSI-approved Apache License, Version 2.0.  See
# accompanying file Copyright.txt for details.
#------------------------------------------------------------------------------#

cmake_minimum_required(VERSION 3.12)
project(ADIOS2HelloSstReaderExample)

if(NOT TARGET adios2_core)
  set(_components CXX)

  find_package(MPI COMPONENTS C)
  if(MPI_FOUND)
    # Workaround for various MPI implementations forcing the link of C++ bindings
    add_definitions(-DOMPI_SKIP_MPICXX -DMPICH_SKIP_MPICXX)

    list(APPEND _components MPI)
  endif()

  if(NOT WIN32)
    find_package(LIBFABRIC 1.6 QUIET)
  endif()

  find_package(ADIOS2 REQUIRED COMPONENTS ${_components})
endif()

if(ADIOS2_HAVE_SST)
  add_executable(adios2_hello_sstReader sstReader.cpp)
  if(ADIOS2_HAVE_MPI)
    target_link_libraries(adios2_hello_sstReader adios2::cxx11_mpi MPI::MPI_C)
  else()
    target_link_libraries(adios2_hello_sstReader adios2::cxx11)
  endif()
  install(TARGETS adios2_hello_sstReader RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

=== debian/changelog ===
adios2 (2.10.2+dfsg1-5build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 21 Oct 2025 10:13:14 +0000

adios2 (2.10.2+dfsg1-5) unstable; urgency=medium

  * Team upload.
  * d/rules: Skip Blosc2 on s390x. Closes: #1115300

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 15 Sep 2025 13:55:09 +0200

adios2 (2.10.2+dfsg1-4) unstable; urgency=medium

  * Team upload.
  * AutoPkgTests: set c++11/c99. Closes: #1115195
  * d/patches: correct metadata
  * Added patch to record only the build system type (Linux) and not the
    build system kernal version to enhance reproducibility. Closes:
    #1104694.
  * Standards-Version: 4.7.2 (routine-update)
  * Do not parse d/changelog (routine-update)
  * d/control: Trim trailing whitespace.
  * d/control: turn off Multi-Arch for some -dev packages, they have
    differing contents.
  * d/rules: set FFLAGS using CPPFLAGS for improved hardening.
  * d/control: fix some package sections.
  * Added patch to fix a typo.
  * d/upstream/metadata: Documented upstream project and their
    recommended citation.
  * AutoPkgTests: set a HOME directory to fix a Segmentation fault.
  * d/rules: switch to Blosc2, add ZFP instead of the no-longer available SST.
  * Added patch to use proper dynamic vector construction to fix
    segfault with gcc-15.
  * Autopkgtests: turn on verbose and debug enabled building of the
    test/examples.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 15 Sep 2025 00:11:40 +0200

adios2 (2.10.2+dfsg1-3) unstable; urgency=medium

  * Team upload
  * Salsa CI: package only build for 64 bits
  * Drop dependency on python3-pkg-resources, dh-cmake is fixed

 -- Alexandre Detiste <tchet@debian.org>  Fri, 08 Aug 2025 19:25:41 +0200

adios2 (2.10.2+dfsg1-2) unstable; urgency=medium

  * Team upload
  * Build-Depend on python3-pkg-resources (Closes: #1100193)

  [ Adrien Nader ]
  * tests: use OpenMPI 5.0's environment variables for over-subscription

 -- Bastian Germann <bage@debian.org>  Thu, 13 Mar 2025 17:50:56 +0100

adios2 (2.10.2+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * update debian patch cmake_config_flavor.patch to add build flavour
    and soname to h5vol support library. Used with HDF5 v1.14.
    Conditionally install in libadios2-*-auxiliary* packages.
    Closes: #1088789.
  * update intra-source-package-circular-dependency lintian overrides
    in debian/source/lintian-overrides

 -- Drew Parsons <dparsons@debian.org>  Fri, 06 Dec 2024 20:34:50 +0100

adios2 (2.10.1+dfsg1-13) unstable; urgency=medium

  * Team upload.

  [ Gilles Filippini ]
  * Fix patch multiple_python_versions.patch so that the corresponding
    Python interpreter is used for each Python release we build against
    (closes: #1086088)

  [ Michael R. Crusoe ]
  * d/salsa-ci.yml: enable Salsa CI testing

  [ Stefano Rivera ]
  * Drop unnecessary Provides: ${python3:Provides}.
  * Install the missing Pure Python bits with a .pyinstall file.
  * Add missing dependency on python3-numpy to python3-adios2.
  * Allow stderr messages in all autopkgtests (for cmake deprecations).

 -- Stefano Rivera <stefanor@debian.org>  Sat, 30 Nov 2024 21:00:25 -0400

=== debian/rules ===
#!/usr/bin/make -f

# define default MPI (ARCH_DEFAULT_MPI_IMPL)
include /usr/share/mpi-default-dev/debian_defaults

export DPKG_EXPORT_BUILDFLAGS = 1
export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_FFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

include /usr/share/dpkg/default.mk

DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')

ADIOS2_UPSTREAM_VERSION=$(DEB_UPSTREAM_VERSION)
ADIOS2_MAJOR_VERSION=$(shell echo $(ADIOS2_UPSTREAM_VERSION) | cut -d . -f 1)
ADIOS2_MINOR_VERSION=$(shell echo $(ADIOS2_UPSTREAM_VERSION) | cut -d . -f 2)

export ADIOS2_SOVERSION=$(ADIOS2_MAJOR_VERSION).$(ADIOS2_MINOR_VERSION)

PYVERS := $(shell py3versions -vs)
PYVERS_LIST := $(shell echo $(PYVERS) | tr " " ";")

get-orig-source:
	wget -O ../adios2_$(DEBIAN_VERSION).orig.tar.gz --no-clobber https://github.com/ornladios/ADIOS2/archive/$(GIT_VERSION).tar.gz
	mkdir tmp
	tar -C tmp --strip-components=1 -xf ../adios2_$(DEBIAN_VERSION).orig.tar.gz
	cd tmp && rm -r \
	  thirdparty/atl \
	  thirdparty/dill \
	  thirdparty/enet \
	  thirdparty/EVPath \
	  thirdparty/ffs \
	  thirdparty/GTest \
	  thirdparty/mingw-w64 \
	  thirdparty/nlohmann_json \
	  thirdparty/pugixml \
	  thirdparty/pybind11 \
	  thirdparty/yaml-cpp
	tar --owner=root --group=root --transform="s/^tmp/adios2_$(DEBIAN_VERSION)+dfsg1/" -cJf ../adios2_$(DEBIAN_VERSION)+dfsg1.orig.tar.xz tmp
	rm -r tmp

flavors := serial mpi

%:
	dh $@ --buildsystem=cmake+ninja

configure_flags_common := \
  -DADIOS2_USE_EXTERNAL_DEPENDENCIES:BOOL=ON \
  -DADIOS2_USE_EXTERNAL_ENET:BOOL=ON \
  -DADIOS2_USE_BZip2:BOOL=ON \
  -DADIOS2_USE_Fortran:BOOL=ON \
  -DADIOS2_USE_HDF5:BOOL=ON \
  -DADIOS2_USE_PNG:BOOL=ON \
  -DADIOS2_USE_ZeroMQ:BOOL=ON \
  -DADIOS2_USE_Python:BOOL=ON \
  -DADIOS2_USE_ZFP:BOOL=ON \
  -DADIOS2_Python_Version="$(PYVERS_LIST)" \
  -DEVPATH_TRANSPORT_MODULES=ON \
  -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON

ifeq ($(DEB_HOST_ARCH_ENDIAN),big)
    configure_flags_common += -DADIOS2_USE_Endian_Reverse=ON -DADIOS2_USE_Blosc2:BOOL=OFF
    EXTRA_CTEST_FLAGS += -E Install.CMake.EncryptionOperator
else 
    configure_flags_common += -DADIOS2_USE_Blosc2:BOOL=ON
endif

configure_flags_serial := $(configure_flags_common) \
  -DCMAKE_INSTALL_CMAKEDIR:STRING=lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2/serial \
  -DADIOS2_LIBRARY_FLAVOR:STRING=serial \
  -DADIOS2_LIBRARY_SUFFIX:STRING=_serial \
  -DADIOS2_EXECUTABLE_SUFFIX:STRING=.serial \
  -DADIOS2_USE_MPI:BOOL=OFF \
  -DHDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5cc

configure_flags_mpi_common := $(configure_flags_common) \
  -DADIOS2_USE_MPI:BOOL=ON \
  -DADIOS2_USE_SSC:BOOL=ON

configure_flags_mpi := $(configure_flags_mpi_common) \
  -DCMAKE_INSTALL_CMAKEDIR:STRING=lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2/mpi \
  -DADIOS2_LIBRARY_FLAVOR:STRING=mpi \
  -DADIOS2_LIBRARY_SUFFIX:STRING=_mpi \
  -DADIOS2_EXECUTABLE_SUFFIX:STRING=.mpi \
  -DMPI_C_COMPILER:FILEPATH=/usr/bin/mpicc.$(ARCH_DEFAULT_MPI_IMPL) \
  -DMPI_CXX_COMPILER:FILEPATH=/usr/bin/mpic++.$(ARCH_DEFAULT_MPI_IMPL) \
  -DMPI_Fortran_COMPILER:FILEPATH=/usr/bin/mpifort.$(ARCH_DEFAULT_MPI_IMPL) \
  -DHDF5_C_COMPILER_EXECUTABLE:FILEPATH=/usr/bin/h5pcc.$(ARCH_DEFAULT_MPI_IMPL)

override_dh_auto_clean:
	dh_clean $(foreach flavor,$(flavors),build-$(flavor)/ install-$(flavor)/)

start_%: flavor = $(patsubst start_%,%,$@)
start_%:
	dh_ctest_start --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor)

override_dh_ctest_start: $(foreach flavor,$(flavors),start_$(flavor))

update_%: flavor = $(patsubst update_%,%,$@)
update_%:
	dh_ctest_update --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor)

override_dh_ctest_update: $(foreach flavor,$(flavors),update_$(flavor))

configure_%: flavor = $(patsubst configure_%,%,$@)
configure_%:
	dh_ctest_configure -O--ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) -O--ctest-build-suffix=-$(flavor) -O--buildsystem=cmake+ninja -- $(configure_flags_$(flavor))

override_dh_ctest_configure: $(foreach flavor,$(flavors),configure_$(flavor))

build_%: flavor = $(patsubst build_%,%,$@)
build_%:
	dh_ctest_build -O--ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) -O--ctest-build-suffix=-$(flavor) -O--buildsystem=cmake+ninja

override_dh_ctest_build: $(foreach flavor,$(flavors),build_$(flavor))

test_%: flavor = $(patsubst test_%,%,$@)
test_%:
	dh_ctest_test --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor) -- -R '^Install\.' $(EXTRA_CTEST_FLAGS)

override_dh_ctest_test: $(foreach flavor,$(flavors),test_$(flavor))

submit_%: flavor = $(patsubst submit_%,%,$@)
submit_%:
	dh_ctest_submit --ctest-testing-dir=build-$(flavor) --builddirectory=build-$(flavor) --ctest-build-suffix=-$(flavor)

override_dh_ctest_submit: $(foreach flavor,$(flavors),submit_$(flavor))

install_%: flavor = $(patsubst install_%,%,$@)
install_%:
	EXTRA_CMAKE_ARGS="-DCMAKE_PREFIX_PATH=$(CMAKE_PREFIX_PATH);$(CURDIR)/install-$(flavor)/usr/lib/$(DEB_HOST_GNU_TYPE)/cmake/adios2/$(flavor)" dh_auto_install --buildsystem=cmake+ninja --builddirectory=build-$(flavor) --destdir=install-$(flavor)
	dh_install --sourcedir=install-$(flavor) --package libadios2-$(flavor)-core-dev usr/bin/adios2-config.$(flavor)

override_dh_auto_install: $(foreach flavor,$(flavors),install_$(flavor))

cmake_install_%: flavor = $(patsubst cmake_install_%,%,$@)
cmake_install_%: cmdbase = dh_cmake_install --builddirectory=build-$(flavor) --sourcedir=install-$(flavor)
cmake_install_%:
	$(cmdbase) --package adios2-$(flavor)-bin                             --component adios2_tools-runtime
	$(cmdbase) --package libadios2-$(flavor)-core-$(ADIOS2_SOVERSION)     --component adios2_core-libraries
	rm -r debian/libadios2-$(flavor)-core-*/usr/lib/*/adios2/$(flavor)
	dh_install --package libadios2-$(flavor)-plugins  --sourcedir=install-$(flavor)  usr/lib/$(DEB_HOST_GNU_TYPE)/adios2/$(flavor)/  usr/lib/$(DEB_HOST_GNU_TYPE)/adios2/
	$(cmdbase) --package libadios2-$(flavor)-core-dev                     --component adios2_core-development
	$(cmdbase) --package libadios2-$(flavor)-c-$(ADIOS2_SOVERSION)        --component adios2_c-libraries
	$(cmdbase) --package libadios2-$(flavor)-c-dev                        --component adios2_c-development
	$(cmdbase) --package libadios2-$(flavor)-c++11-$(ADIOS2_SOVERSION)    --component adios2_cxx11-libraries
	$(cmdbase) --package libadios2-$(flavor)-c++11-dev                    --component adios2_cxx11-development
	$(cmdbase) --package libadios2-$(flavor)-fortran-$(ADIOS2_SOVERSION)  --component adios2_fortran-libraries
	$(cmdbase) --package libadios2-$(flavor)-fortran-dev                  --component adios2_fortran-development

cmake_install_serial_extra: cmdbase = dh_cmake_install --builddirectory=build-serial --sourcedir=install-serial
cmake_install_serial_extra:
	$(cmdbase) --package python3-adios2           --component adios2_python-python
	rm -f debian/python3-adios2/usr/lib/python3/dist-packages/adios2/bindings/adios2_bindings_serial*.so
	for pyver in $(PYVERS); do \
	  $(cmdbase) --package python3-adios2-serial  --component adios2_python-python$$pyver; \
	done

cmake_install_mpi_extra: cmdbase = dh_cmake_install --builddirectory=build-mpi --sourcedir=install-mpi
cmake_install_mpi_extra:
	$(cmdbase) --package python3-adios2           --component adios2_python-python
	rm -f debian/python3-adios2/usr/lib/python3/dist-packages/adios2/bindings/adios2_bindings_mpi*.so
	for pyver in $(PYVERS); do \
	  $(cmdbase) --package python3-adios2-mpi       --component adios2_python-python$$pyver; \
	done
	$(cmdbase) --package adios2-data              --component adios2_tools-data

override_dh_cmake_install: cmdbase = dh_cmake_install --builddirectory=build-serial --sourcedir=install-serial
